.TH authd 8
.SH NAME
authd \- Authentication Server daemon
.SH SYNTAX
authd
[
\fB\-ACHUVW\fI
]
.SH DESCRIPTION
.I authd
is a simple daemon implementing the
RFC 931 Authentication Server protocol.
It should be invoked by a network server,
such as
.I attachport(1),
for connections to TCP port 113.
.PP
The client host
gives
.I authd
two numbers separated by a comma.
.I authd
interprets the numbers as TCP port numbers
for the local and remote sides respectively
of a TCP connection between this host and the client host.
It returns a line of the form
.EX
localport, remoteport: USERID: UNIX: username
.EE
where username
is the name of the user on this side of
the specified connection.
If
.I authd
does not have an authentication entry for that connection,
it returns a line of the form
.EX
localport, remoteport: ERROR: UNKNOWN-ERROR.
.EE
.PP
Options
.B ACHUVW
print the authorship notice,
copyright notice,
help notice,
short usage summary,
version number,
and warranty information respectively.
.PP
.SH DIAGNOSTICS
.TP
None.
.SH MACHINES
.I authd
has been tested
on an Astronautics ZS-2
running ZSUnix,
a Sun 3 running SunOS,
a Sun 4 running SunOS,
a Convex C-210 running Convex UNIX,
and several other machines.
.SH FILES
/usr/etc/auth/tcp/*
.SH BUGS
None known.
.SH RESTRICTIONS
.I authd
does not require kernel support;
it must be supported on the user level by
.I authtcp
and
.I attachport.
If those programs are not used,
.I authd
is useless.
.PP
The author feels quite confident in predicting that
the first problems people have with
.I authd
will be on multihomed hosts.
Programmers be warned: It takes some effort
to correctly use
.I authd
on a multihomed host!
.SH VERSION
authd version 2.1, dated April 18, 1990.
.SH AUTHOR
Copyright 1990, Daniel J. Bernstein.
.SH REFERENCES
The authentication server is more secure than passwords
in some ways, but less secure than passwords in many ways.
(It's certainly better than no password at all---e.g., for
mail or news.)
It is not the final solution.
For an excellent discussion of security problems within
the TCP/IP protocol suite, see
Steve Bellovin's article
``Security Problems in the TCP/IP Protocol Suite.''
.SH "SEE ALSO"
authtcp(1),
attachport(1),
authuser(3),
tcp(4),
inetd(8)
