.TH SENDFILE 1 "LOCAL"
.SH NAME
sendfile \- send a file to VM or to another node via RSCS
.SH SYNOPSIS
sendfile [-v <user> -d <node> -o -p] <file>
.SH DESCRIPTION
Sendfile reads a text file, converts it to EBCDIC, and sends it
to a VM user or, via RSCS, to a user at another NJE node.
The default file format is CMS NETDATA.
The command line options are:
.TP 12
-d <node>
Specifies the destination node name.
The default is the local node.
.TP 12
-v <user>
Specifies the destination user name.
The default is taken from the environment variable $VMID.
.TP 12
-o
The file will be sent in CMS DISK DUMP format.
.TP 12
-p
The file will be sent in CMS PUNCH format.
.SH EXAMPLES
Send a file to user MILLS on node UOFMCC:
.ti+2n
sendfile -d uofmcc -v mills hello.c
.SH SEE ALSO
lp(1), diskdump(1x), netdata(1x)
.SH BUGS
Sendfile will not handle binary files.
The CMS file produced is always sequental and format V.
The ASCII to EBCDIC translation may not conform to what is expected
on the receiving system.
